---
title: 'TypeError: invalid arguments'
slug: Web/JavaScript/Reference/Errors/Typed_array_invalid_arguments
tags:
  - Error
  - Errors
  - JavaScript
  - TypeError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "invalid arguments" occurs when <a href="/en-US/docs/Web/JavaScript/Typed_arrays">typed array</a> constructors are provided with a wrong argument.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">TypeError: invalid arguments (Firefox)</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("TypeError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p><a href="/en-US/docs/Web/JavaScript/Typed_arrays">Typed array</a> constructors require either</p>

<ul>
 <li>a length,</li>
 <li>another typed array,</li>
 <li>array-like objects,</li>
 <li>iterable objects or</li>
 <li>an {{jsxref("ArrayBuffer")}} object</li>
</ul>

<p>to create a new typed array. Other constructor arguments will not create a valid typed array.</p>

<h2 id="Examples">Examples</h2>

<h3 id="No_strings_in_typed_arrays">No strings in typed arrays</h3>

<p>Typed arrays, for example a {{jsxref("Uint8Array")}}, can't be constructed from a string. In fact, strings can't be in typed arrays at all.</p>

<pre class="brush: js example-bad">var ta = new Uint8Array("nope");
// TypeError: invalid arguments
</pre>

<p>Different ways to create a valid {{jsxref("Uint8Array")}}:</p>

<pre class="brush: js example-good">// From a length
var uint8 = new Uint8Array(2);
uint8[0] = 42;
console.log(uint8[0]); // 42
console.log(uint8.length); // 2
console.log(uint8.BYTES_PER_ELEMENT); // 1

// From an array
var arr = new Uint8Array([21,31]);
console.log(arr[1]); // 31

// From another TypedArray
var x = new Uint8Array([21, 31]);
var y = new Uint8Array(x);
console.log(y[0]); // 21

// From an ArrayBuffer
var buffer = new ArrayBuffer(8);
var z = new Uint8Array(buffer, 1, 4);

// From an iterable
var iterable = function*(){ yield* [1,2,3]; }();
var uint8 = new Uint8Array(iterable);
// Uint8Array[1, 2, 3]
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Typed_arrays">Typed arrays</a></li>
 <li>{{jsxref("ArrayBuffer")}}</li>
 <li>{{jsxref("Uint8Array")}}</li>
</ul>
